DetectCollisions:

	ld	a,(active_bullets)
	or	a
	ret	z

	ld	a,(active_meteors)
	or	a
	ret	z
	ld	c,a	;Number of meteors into loop counter

	ld	ix,meteor_array - m_entry_size
DC_MeteorLoop:
	ld	de,m_entry_size
	add	ix,de

	ld	a,(ix + active)
	or	a
	jr	z,DC_MeteorLoop + 3

	ld	a,(active_bullets)
	or	a
	ret	z
	ld	b,a

	ld	hl,bullet_array - b_entry_size
	ld	de,b_entry_size
DC_BulletLoop:
	add	hl,de
	ld	a,(hl)
	or	a
	jr	z,DC_BulletLoop

	push	hl
		call	BBox_Test
		;Carry set on failure
		jp	c,DC_NoHit

		dec	(ix + active)		;Invalid meteor
		ld	hl,active_meteors
		dec	(hl)
		ld	hl,active_bullets
		dec	(hl)
		ld	hl,(kills)
		inc	hl
		ld	(kills),hl
	pop	hl

	dec	(hl)			;Invalid bullet
	jr	DC_Rejump

DC_NoHit:
	pop	hl
	djnz	DC_BulletLoop

DC_Rejump:
	dec	c
	jr	nz,DC_MeteorLoop
	ret

.end